<?php
/**
 * @copyright	Copyright (C) 2016 Cedric KEIFLIN alias ced1870
 * http://www.joomlack.fr
 * @license		GNU/GPL
 * */
 
defined('_JEXEC') or die('Restricted access');

?><?php
class plgHikashopMaximenuck extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('hikashop', 'maximenuck');
			$this->params = new JRegistry($plugin->params);
		}
	}

	function onHikashopBeforeDisplayView($view) {
		$app = JFactory::getApplication();
		// si pas en frontend, on sort
		if (! $app->isClient('administrator')) {
			return false;
		}
		if (! isset($view->element)) return;
		$input = $app->input;
		// loads the language files from the frontend
		$lang	= JFactory::getLanguage();
		$lang->load('plg_system_maximenuck_hikashop', JPATH_SITE . '/plugins/system/maximenuck_hikashop', $lang->getTag(), false);

		JHtml::_('jquery.framework');
		$doc = JFactory::getDocument();
		$doc->addStylesheet(JUri::root(true) . '/administrator/components/com_maximenuckhikashop/assets/ckbox.css');
		$doc->addScript(JUri::root(true) . '/administrator/components/com_maximenuckhikashop/assets/ckbox.js');
		$doc->addScriptDeclaration("function ckSetFaIcon(iclass) {
				jQuery('#maximenu_icon').val(iclass).trigger('change');
				CKBox.close();
		}");

		// $ckparams = $input->get('ckparams', '', 'array');

		$ckparams = isset($view->element->ckparams) ? new JRegistry($view->element->ckparams) : new JRegistry();
		// $maximenuckparams = $ckparams->get('maximenu', '') ? new JRegistry($ckparams->get('maximenu', '')) : new JRegistry();
		$view->extra_blocks['category']['maximenu_heading'] = '<tr><td colspan="2"><div style="font-size: 20px;padding: 10px 0;">Maximenu CK Options</div></td></tr>';
		$view->extra_blocks['category']['maximenu_itemheading'] = array(
			'name'=>'<b>' . JText::_('PLG_MAXIMENUCK_HIKASHOP_ITEM_HEADING') . '</b>',
			'value'=>''
			);
		$view->extra_blocks['category']['maximenu_desc'] = array(
			'name'=>JText::_('PLG_MAXIMENUCK_HIKASHOP_ITEM_DESCRIPTION'),
			'value'=>'<input id="maximenu_desc" name="ckparams[maximenu_desc]" type="text" value="' . $ckparams->get('maximenu_desc') . '"/>'
			);
		$view->extra_blocks['category']['maximenu_icon'] = array(
			'name'=>JText::_('PLG_MAXIMENUCK_HIKASHOP_ICON'),
			'value'=>'<input id="maximenu_icon" name="ckparams[maximenu_icon]" type="text" value="' . $ckparams->get('maximenu_icon') . '"/>
			<span class="btn" onclick="CKBox.open({url: \'index.php?option=com_maximenuckhikashop&view=icons&tmpl=component&returnFunc=ckSetFaIcon\'})">' . JText::_('PLG_MAXIMENUCK_HIKASHOP_SELECT') . '</span>'
			);
		$view->extra_blocks['category']['maximenu_type'] = array(
			'name'=>JText::_('PLG_MAXIMENUCK_HIKASHOP_TYPE'),
			'value'=>'<select id="maximenu_type" name="ckparams[maximenu_type]">
				<option value="" '.($ckparams->get('maximenu_type') == '' ? 'selected' : '').'>'.JText::_('PLG_MAXIMENUCK_HIKASHOP_LINK').'</option>
				<option value="separator" '.($ckparams->get('maximenu_type') == 'separator' ? 'selected' : '').'>'.JText::_('PLG_MAXIMENUCK_HIKASHOP_NO_LINK').'</option>
				<option value="heading" '.($ckparams->get('maximenu_type') == 'heading' ? 'selected' : '').'>'.JText::_('PLG_MAXIMENUCK_HIKASHOP_HEADING').'</option>
				</select>'
			);
		$view->extra_blocks['category']['maximenu_liclass'] = array(
			'name'=>JText::_('PLG_MAXIMENUCK_HIKASHOP_LI_CLASS'),
			'value'=>'<input id="maximenu_liclass" name="ckparams[maximenu_liclass]" type="text" value="' . $ckparams->get('maximenu_liclass') . '"/>'
			);
		$view->extra_blocks['category']['maximenu_tagcoltitle'] = array(
			'name'=>JText::_('PLG_MAXIMENUCK_HIKASHOP_HTMLTAG_LABEL'),
			'value'=>'<select id="maximenu_tagcoltitle" name="ckparams[maximenu_tagcoltitle]">
				<option value="none" '.($ckparams->get('maximenu_tagcoltitle') == 'none' ? 'selected' : '').'>'.JText::_('JNONE').'</option>
				<option value="div" '.($ckparams->get('maximenu_tagcoltitle') == 'div' ? 'selected' : '').'>'.JText::_('DIV').'</option>
				<option value="p" '.($ckparams->get('maximenu_tagcoltitle') == 'p' ? 'selected' : '').'>'.JText::_('p').'</option>
				<option value="h2" '.($ckparams->get('maximenu_tagcoltitle') == 'h2' ? 'selected' : '').'>'.JText::_('h2').'</option>
				<option value="h3" '.($ckparams->get('maximenu_tagcoltitle') == 'h3' ? 'selected' : '').'>'.JText::_('h3').'</option>
				<option value="h4" '.($ckparams->get('maximenu_tagcoltitle') == 'h4' ? 'selected' : '').'>'.JText::_('h4').'</option>
				<option value="h5" '.($ckparams->get('maximenu_tagcoltitle') == 'h5' ? 'selected' : '').'>'.JText::_('h5').'</option>
				<option value="h6" '.($ckparams->get('maximenu_tagcoltitle') == 'h6' ? 'selected' : '').'>'.JText::_('h6').'</option>
				</select>'
			);
		$view->extra_blocks['category']['maximenu_disablemobile'] = array(
			'name'=>JText::_('PLG_MAXIMENUCK_HIKASHOP_DISABLE_MOBILE'),
			'value'=>'
			<div id="maximenu_disablemobile" class="hikaradios">
				<input id="maximenu_disablemobileyes" class="btn-success" name="ckparams[maximenu_disablemobile]" value="1" '.($ckparams->get('maximenu_disablemobile') == '1' ? 'checked="checked"' : '').' style="display:none;" onchange="hikashopLocal.radioEvent(this);" type="radio">
				<input id="maximenu_disablemobileno" class="btn-danger" name="ckparams[maximenu_disablemobile]" value="0" '.($ckparams->get('maximenu_disablemobile') != '1' ? 'checked="checked"' : '').' style="display:none;" onchange="hikashopLocal.radioEvent(this);" type="radio">
				<div class="btn-group" data-toggle="buttons-radio">
					<label class="btn '.($ckparams->get('maximenu_disablemobile') == '1' ? 'btn-success active' : '').'" for="maximenu_disablemobileyes">'.JText::_('JYES').'</label>
					<label class="btn '.($ckparams->get('maximenu_disablemobile') != '1' ? 'btn-danger active' : '').'" for="maximenu_disablemobileno">'.JText::_('JNO').'</label>
				</div>
			</div>'
			);
		$view->extra_blocks['category']['maximenu_disabledesktop'] = array(
			'name'=>JText::_('PLG_MAXIMENUCK_HIKASHOP_DISABLE_DESKTOP'),
			'value'=>'
			<div id="maximenu_disabledesktop" class="hikaradios">
				<input id="maximenu_disabledesktopyes" class="btn-success" name="ckparams[maximenu_disabledesktop]" value="1" '.($ckparams->get('maximenu_disabledesktop') == '1' ? 'checked="checked"' : '').' style="display:none;" onchange="hikashopLocal.radioEvent(this);" type="radio">
				<input id="maximenu_disabledesktopno" class="btn-danger" name="ckparams[maximenu_disabledesktop]" value="0" '.($ckparams->get('maximenu_disabledesktop') != '1' ? 'checked="checked"' : '').' style="display:none;" onchange="hikashopLocal.radioEvent(this);" type="radio">
				<div class="btn-group" data-toggle="buttons-radio">
					<label class="btn '.($ckparams->get('maximenu_disabledesktop') == '1' ? 'btn-success active' : '').'" for="maximenu_disabledesktopyes">'.JText::_('JYES').'</label>
					<label class="btn '.($ckparams->get('maximenu_disabledesktop') != '1' ? 'btn-danger active' : '').'" for="maximenu_disabledesktopno">'.JText::_('JNO').'</label>
				</div>
			</div>'
			);
		$view->extra_blocks['category']['maximenu_columnheading'] = array(
			'name'=>'<b>' . JText::_('PLG_MAXIMENUCK_HIKASHOP_COLUMN_HEADING') . '</b>',
			'value'=>''
			);
		$view->extra_blocks['category']['maximenu_createcolumn'] = array(
			'name'=>JText::_('PLG_MAXIMENUCK_HIKASHOP_NEW_COLUMN'),
			'value'=>'
			<div id="maximenu_createcolumn" class="hikaradios">
				<input id="maximenu_createcolumnyes" class="btn-success" name="ckparams[maximenu_createcolumn]" value="1" '.($ckparams->get('maximenu_createcolumn') == '1' ? 'checked="checked"' : '').' style="display:none;" onchange="hikashopLocal.radioEvent(this);" type="radio">
				<input id="maximenu_createcolumnno" class="btn-danger" name="ckparams[maximenu_createcolumn]" value="0" '.($ckparams->get('maximenu_createcolumn') != '1' ? 'checked="checked"' : '').' style="display:none;" onchange="hikashopLocal.radioEvent(this);" type="radio">
				<div class="btn-group" data-toggle="buttons-radio">
					<label class="btn '.($ckparams->get('maximenu_createcolumn') == '1' ? 'btn-success active' : '').'" for="maximenu_createcolumnyes">'.JText::_('JYES').'</label>
					<label class="btn '.($ckparams->get('maximenu_createcolumn') != '1' ? 'btn-danger active' : '').'" for="maximenu_createcolumnno">'.JText::_('JNO').'</label>
				</div>
			</div>'
			);
		$view->extra_blocks['category']['maximenu_colwidth'] = array(
			'name'=>JText::_('PLG_MAXIMENUCK_HIKASHOP_COLUMN_WIDTH'),
			'value'=>'<input id="colwidth" name="ckparams[maximenu_colwidth]" type="text" value="' . $ckparams->get('maximenu_colwidth') . '"/>'
			);
		$view->extra_blocks['category']['maximenu_createnewrow'] = array(
			'name'=>JText::_('PLG_MAXIMENUCK_HIKASHOP_NEW_ROW'),
			'value'=>'
			<div id="maximenu_createnewrow" class="hikaradios">
				<input id="maximenu_createnewrowyes" class="btn-success" name="ckparams[maximenu_createnewrow]" value="1" '.($ckparams->get('maximenu_createnewrow') == '1' ? 'checked="checked"' : '').' style="display:none;" onchange="hikashopLocal.radioEvent(this);" type="radio">
				<input id="maximenu_createnewrowno" class="btn-danger" name="ckparams[maximenu_createnewrow]" value="0" '.($ckparams->get('maximenu_createnewrow') != '1' ? 'checked="checked"' : '').' style="display:none;" onchange="hikashopLocal.radioEvent(this);" type="radio">
				<div class="btn-group" data-toggle="buttons-radio">
					<label class="btn '.($ckparams->get('maximenu_createnewrow') == '1' ? 'btn-success active' : '').'" for="maximenu_createnewrowyes">'.JText::_('JYES').'</label>
					<label class="btn '.($ckparams->get('maximenu_createnewrow') != '1' ? 'btn-danger active' : '').'" for="maximenu_createnewrowno">'.JText::_('JNO').'</label>
				</div>
			</div>'
			);
		$view->extra_blocks['category']['maximenu_submenuheading'] = array(
			'name'=>'<b>' . JText::_('PLG_MAXIMENUCK_HIKASHOP_SUBMENU_HEADING') . '</b>',
			'value'=>''
			);
		$view->extra_blocks['category']['maximenu_submenucontainerwidth'] = array(
			'name'=>JText::_('PLG_MAXIMENUCK_HIKASHOP_SUBMENU_CONTAINER_WIDTH'),
			'value'=>'<input id="submenucontainerwidth" name="ckparams[maximenu_submenucontainerwidth]" type="text" value="' . $ckparams->get('maximenu_submenucontainerwidth') . '"/>'
			);
		$view->extra_blocks['category']['maximenu_submenucontainerheight'] = array(
			'name'=>JText::_('PLG_MAXIMENUCK_HIKASHOP_SUBMENU_CONTAINER_WIDTH'),
			'value'=>'<input id="submenucontainerheight" name="ckparams[maximenu_submenucontainerheight]" type="text" value="' . $ckparams->get('maximenu_submenucontainerheight') . '"/>'
			);
		$view->extra_blocks['category']['maximenu_leftmargin'] = array(
			'name'=>JText::_('PLG_MAXIMENUCK_HIKASHOP_LEFT_MARGIN'),
			'value'=>'<input id="leftmargin" name="ckparams[maximenu_leftmargin]" type="text" value="' . $ckparams->get('maximenu_leftmargin') . '"/>'
			);
		$view->extra_blocks['category']['maximenu_topmargin'] = array(
			'name'=>JText::_('PLG_MAXIMENUCK_HIKASHOP_TOP_MARGIN'),
			'value'=>'<input id="topmargin" name="ckparams[maximenu_topmargin]" type="text" value="' . $ckparams->get('maximenu_topmargin') . '"/>'
			);
	}

	function onAfterCategoryUpdate(&$element) {
		// $this->saveOptions($element);
	}

	function onAfterCategoryCreate(&$element) {
		// $this->saveOptions($element);
	}

	function onBeforeCategoryCreate(&$element) {
		$db = JFactory::getDbo();
		$input = JFactory::getApplication()->input;
		$ckparams = $input->get('ckparams', '', 'array');
		$element->ckparams = json_encode($ckparams);
	}

	function onBeforeCategoryUpdate(&$element) {
		$db = JFactory::getDbo();
		$input = JFactory::getApplication()->input;
		$ckparams = $input->get('ckparams', '', 'array');
		$element->ckparams = json_encode($ckparams);
	}

	public function onHikashopBeforeCheckDB(&$createTable, &$custom_fields, &$structure, &$helper) {
		$structure['#__hikashop_category']['ckparams'] = '`ckparams` text NOT NULL';
	}
}
